CoCoA-5 - Design #294

BuiltinFunctions: General "OneLiner" for arguments of different type
23 Jan 2013 12:51 - Anna Maria Bigatti
Category: Parser/Interpreter Estimated time: 2.00 hours
Target version: CoCoA-5.1.1 Seoul14 Spent time: 1.75 hour
Description

one liner functions work like a dream (thanks Giovanni! ;-)

Is it possible to simplify writing the code for overloaded functions?
E.g.

IsZero(RINGELEM/INT/RAT/...)

2014-08 conclusion: using switch with improved function names and behaviour (documented)

Related issues:

Related to CoCoA-5 - Feature #306: Function for accessing the pointed value Closed 12 Feb 2013
Related to CoCoA-5 - Bug #524: BuiltinFunctions: remove calls to WrongTypeExc... Closed 08 Apr 2014
Related to CoCoA-5 - Feature #317: BuiltinFunctions: evalArgAsLong Closed 20 Feb 2013
Related to CoCoA-5 - Design #525: BuiltinFunctions: evalArgAsT10rT2, evalArgA... Closed 08 Apr 2014
Is duplicate of CoCoA-5 - Feature #284: BuiltinFunctions: more flexible typin... Closed 05 Dec 2012
History

#1 - 24 Jan 2013 08:28 - Anna Maria Bigatti

Not quite the dream solution, but | found this function making life easier:
evalArgAsT1orT20rT3

int which;
intrusive_ptr<RightValue> v = runtimeEnv->evalArgAsTlorT20rT3<BigIntValue, BigRatValue, RingElemValue> (ARG (0),
which) ;

#2 - 12 Feb 2013 11:57 - Anna Maria Bigatti
added also evalArgAsT1orT2orT30rT4 and evalArgAsT1orT2orT3orT4orT5

#3 - 28 Mar 2014 09:07 - Anna Maria Bigatti

- Subject changed from General "OneLiner" for arguments of different type to BuiltinFunctions: General "OneLiner" for arguments of different type

#4 - 08 Apr 2014 08:25 - Anna Maria Bigatti

- Status changed from New to Closed
#5 - 08 Apr 2014 08:27 - Anna Maria Bigatti

- Status changed from Closed to In Progress

- Target version changed from CoCoA-5.1.0 Easter14 to CoCoA-5.1.1 Seoul14
#6 - 31 Jul 2014 15:08 - Anna Maria Bigatti

- Status changed from In Progress to Resolved
- % Done changed from 0 to 70

- Estimated time set to 2.00 h

Is the new approach in BuiltinFunctions good enough?
| think so: it is not a one-liner but it's very readable (look for EvalArgAsT10r..)

Close this issue?

#7 - 05 Sep 2014 11:51 - Anna Maria Bigatti
- Status changed from Resolved to Closed
- Assignee set to Anna Maria Bigatti

- % Done changed from 70 to 100

Documented in

http://cocoa.dima.unige.it/cocoalib/doc/html/BuiltinFunctions.html

and in ICMS slides
https://www.researchgate.net/publication/262797206_Integration_of_libnormaliz_in_CoCoALib_and_CoCoA_5
